/****************************************/
/* LIBRARY                              */
/****************************************/
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <stdlib.h>


/****************************************************************/
/* STRUCTURES                                                   */
/****************************************************************/
typedef struct
{
        double *details;
        int *length;

}WAVE;

typedef struct
{
        double **approximations;
        double **details;

}WAVETYPE;

typedef struct
{
        double *approximation;
        double *details;

}DWTTYPE;

/****************************************************************/
/* CONSTANTS                                                    */
/****************************************************************/
#define max(x,y)  ( (x)>(y) ? (x) : (y) )
#define min(x,y)  ( (x)<(y) ? (x) : (y) )
#define CHARSIZE 2000
#define lf 20


/****************************************************************/
/* GLOBAL VARIABLES                                             */
/****************************************************************/
int WIN, LEVEL;
double Lo_D[20],Hi_D[20],Lo_R[20],Hi_R[20];

/****************************************************************/
/* FUNCTIONS                                                    */
/****************************************************************/
double **GetIndexKey(char *,int *);
double **GetSignal(char *,double **,int);
double **SigWin(double **,int,int);
double **GetWave(double **,int,int,char);
double **GetSlope(double **,int,int);
double *GetWaveSingle(double *,int);
double *SigWinSingle(double *,int);
double *zscore(double *,int);
WAVETYPE approximation(WAVE,int, int,int,int);
double *wrcoef_d(double *,int *,int,int);
double *wrcoef_a(double *,int *,int,int);
double *appcoef(double *,int *,int,int *,int);
double *idwt(double *,double *,int,int *,int,int);
double *upsaconv(double *,double *,int,int *,int);
double *wkeep_r(double *,int,int,int *);
double *detcoef(double *,int *, int,int,int *);
WAVE wavedec(double *, int ,int ,int *, int *);
DWTTYPE dwt(double *,int *, int *);
double *dyaddown(double *,int);
double *wkeep(double *,int,int *,int);
double *conv2(double *, double *,int, int);
int *getSymIndices(int,int,int *);
int num_lines(FILE *);

