#include "fasta.h"

/************************************************************************/
/* Function: fasta							*/
/* Purpose: Input filename in fasta format and output fasta sequences 	*/
/************************************************************************/
FASTATYPE *fasta(char *filename,int *output_num)
{
	FILE *fid;
	long gene_num,count=-1,len,total_len=0,i,len_seq;
	FASTATYPE *output;
	char tline[CHARSIZE],*ctmp1,*ctmp2;
	int a;	
	
	if((fid=fopen(filename,"rt"))==NULL)
	{ printf("Error : cannot open %s !\n",filename); exit(0); }

	gene_num=num_lines_gene(fid);
	if((output=(FASTATYPE *)calloc(gene_num,sizeof(FASTATYPE)))==NULL)
	{ printf("Error : calloc to output[gene_num] \n"); exit(0); }

	if((ctmp2=(char *)calloc(total_len,sizeof(char)))==NULL)
	{ printf("Error : calloc to ctmp2[total_len] \n"); exit(0); }

	while ( fgets(tline,CHARSIZE,fid) )
	{
		len=strlen(tline);
		
		if (tline[0]=='>')
		{
			count++;
			if((output[count].name=(char *)calloc(len-2,sizeof(char)))==NULL)
			{ printf("Error : calloc to output[count].name[len-2] \n"); exit(0); }
			for (i=1;i<len-1;i++)		output[count].name[i-1]=tline[i];

			if (count>0)
			{
				len_seq=0;
				for (i=0;i<total_len;i++)	
					if ((toupper(ctmp2[i])>=65 && toupper(ctmp2[i])<=90) || (toupper(ctmp2[i])==45))	len_seq++;
				if((output[count-1].seq=(char *)calloc(len_seq+1,sizeof(char)))==NULL)
				{ printf("Error : calloc to output[count].seq[total_len] \n"); exit(0); }
				for (i=0;i<len_seq;i++)
					output[count-1].seq[i]=toupper(ctmp2[i]);
				output[count-1].seq[len_seq]='\0';
				output[count-1].seq_len=len_seq;
				total_len=0;
			}

		}
		else
		{
			if (tline[len-1]=='\n')	len--;
			if((ctmp1=(char *)calloc(len+total_len,sizeof(char)))==NULL)
			{ printf("Error : calloc to ctmp1[toal_len+len] \n"); exit(0); }
			for (i=0;i<total_len;i++)		
				ctmp1[i]=toupper(ctmp2[i]);
			for (i=total_len;i<total_len+len;i++)
				ctmp1[i]=tline[i-total_len];

			free(ctmp2);
			total_len+=len;
			if((ctmp2=(char *)calloc(total_len,sizeof(char)))==NULL)
			{ printf("Error : calloc to ctmp2[total_len] \n"); exit(0); }
			for (i=0;i<total_len;i++)	ctmp2[i]=toupper(ctmp1[i]);
			free(ctmp1);
							
		}
					
	}		
	//Store last seq
	count++;
	len_seq=0;
	for (i=0;i<total_len;i++)	
		if ((toupper(ctmp2[i])>=65 && toupper(ctmp2[i])<=90) || (toupper(ctmp2[i])==45))	len_seq++;
	if((output[count-1].seq=(char *)calloc(len_seq+1,sizeof(char)))==NULL)
	{ printf("Error : calloc to output[count].seq[total_len] \n"); exit(0); }
	for (i=0;i<len_seq;i++)
		output[count-1].seq[i]=toupper(ctmp2[i]);
	output[count-1].seq[len_seq]='\0';
	output[count-1].seq_len=len_seq;
	free(ctmp2);

	
	fclose(fid);	
	*output_num=gene_num;
	return output;
}

int num_lines_gene(FILE *fin)
{
	long n=0,c;
	char tline[CHARSIZE];
	while (!feof(fin))
	{	
		fgets(tline,CHARSIZE,fin);
		if (tline[0]=='>')
		{
			n+=1;
		}
	}
	
	rewind(fin);
	return(n);

}
